Program afcextr;
{$APPTYPE CONSOLE}
Const AFC_BlockAlign = $8000;
Var
    Fl, F: File;
    Sz, I: Integer;
        P: Pointer;
        S: String;
Begin
  WriteLn('Mass Effect 2 .AFC extractor');
  WriteLn('(c) CTPAX-X Team 2010');
  WriteLn('http://www.CTPAX-X.ru/');
  WriteLn;
  If ParamCount <> 1 Then
    Begin
      WriteLn('Usage: afcextr filename.afc');
      Exit;
    End;
  AssignFile(Fl, ParamStr(1));
  FileMode:=0;
  {$I-}
  Reset(Fl, 1);
  {$I+}
  FileMode:=2;
  If IOResult <> 0 Then
    Begin
      WriteLn('Can''t open file: ' + ParamStr(1));
      Exit;
    End;
  I:=0;
  While Not EOF(Fl) Do
    Begin
      BlockRead(Fl, Sz, 4);
      If Sz = $46464952 Then // RIFF
        Begin
          I:=I + 1;
          Str(I, S);
          While Length(S) < 3 Do S:='0' + S;
          S:=Copy(ParamStr(1), 1, Length(ParamStr(1)) - 3) + S + '.wav';
          Write(S);
          BlockRead(Fl, Sz, 4);
          Seek(Fl, FilePos(Fl) - 8);
          Sz:=Sz + 8;
          GetMem(P, Sz);
          BlockRead(Fl, P^, Sz);
          AssignFile(F, S);
          ReWrite(F, 1);
          BlockWrite(F, P^, Sz);
          CloseFile(F);
          FreeMem(P, Sz);
          Seek(Fl, FilePos(Fl) - Sz + AFC_BlockAlign);
          WriteLn;
        End
      Else
        Seek(Fl, FilePos(Fl) - 4 + AFC_BlockAlign);
    End;
End.
